/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_bozo_sort.c                                     :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angouleme.fr  +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/12/09 14:24:03 by cchauvet          #+#    #+#             */
/*   Updated: 2022/12/11 15:13:33 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "pushswap.h"

static void	ft_specific_bozo_sort(t_tab tab_a)
{
	if (ft_tablen(tab_a) < 3)
	{
		if (!ft_is_sorted(tab_a))
			ft_ra(tab_a);
	}
	else
	{
		if (tab_a[0] == tab_a[1] - 1)
			ft_rra(tab_a);
		if (tab_a[0] == tab_a[1] + 1 && tab_a[1] == tab_a[2] + 1)
		{
			ft_ra(tab_a);
			ft_sa(tab_a);
		}
		if (tab_a[0] == tab_a[1] + 1)
			ft_sa(tab_a);
	}
}

void	ft_bozo_sort(t_tab tab_a, t_tab tab_b)
{
	if (ft_is_sorted(tab_a))
		return ;
	while (ft_tablen(tab_a) > 3)
	{
		while ((long) tab_a[0] >= ft_tablen(tab_a) + ft_tablen(tab_b) - 3)
			ft_ra(tab_a);
		ft_pb(tab_a, tab_b);
	}
	ft_specific_bozo_sort(tab_a);
	if (!ft_is_sorted(tab_a))
	{
		ft_pb(tab_a, tab_b);
		if (!ft_is_sorted(tab_a))
			ft_ra(tab_a);
		ft_pa(tab_a, tab_b);
		if (!ft_is_sorted(tab_a))
			ft_ra(tab_a);
	}
	if (ft_is_sorted(tab_b) && ft_tablen(tab_b) > 1)
		ft_rb(tab_b);
	while (ft_tablen(tab_b) != 0)
		ft_pa(tab_a, tab_b);
}
